#
# DO NOT EDIT THIS FILE, CHANGES WILL BE LOST
#
# Created by Makefile.PL 
# (IANA/build_codes.pl)
# from	IANA/protocols
# and	IANA/icmp
# Tue Oct  8 16:33:41 2013
#
package LaBrea::Codes;
use strict;
use vars qw($VERSION @ISA @EXPORT_OK %prot %pnum %icmp %inum );

$VERSION = do { my @r = (q$Revision: 0.01 $ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r };

require Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(
	protocol
	icmp
);

=head1 NAME

  LaBrea::Tarpit::Codes

=head1 SYNOPSIS

  use LaBrea::Tarpit::Codes qw (
	protocol
	icmp
	numeric
  );

  $text	  = protocol(number);
  $number = protocol(text);
  $text   = icmp(number);
  $number = icmp(text);
  $rv	  = numeric(scalar);

=head1 DESCRIPTION

This module is built by B<Makefile.PL> from the text files 
in the IANA subdirectory (copied from the IANA web site).

Do not edit the Codes.pm file, changes will be lost.

=over 4

=item $rv = protocol($x);

  Returns the upper case text name of a protocol
  number or the protocol number of a text name.

  i.e.  'TCP' = protocol(6);
	  6   = protocol('Tcp');
	  (not case sensitive)

  return -1 or 'unknown' if lookup value 
  is not present in table

=cut
  
sub protocol { 
    if (numeric($_[0])) {	# seeking numeric
	my $v = uc $_[0];
	return (exists $pnum{$v}) ? $pnum{$v} : -1;
    } else {			# seeking text
	return (exists $prot{$_[0]}) ? $prot{$_[0]} : 'unknown';
    }
}

=item $rv = icmp($x);

  Returns the upper case text name of an icmp
  number or the icmp number of the text name.

  i.e.	'ECHO' = icmp(8);
	   8   = icmp('EcHo');
	   (not case sensitive)

  return -1 or 'unknown' if lookup value 
  is not present in table

=cut

sub icmp {
    if (numeric($_[0])) {	# seeking numeric
	my $v = uc $_[0];
	return (exists $inum{$v}) ? $inum{$v} : -1;
    } else {			# seeking text
	return (exists $icmp{$_[0]}) ? $icmp{$_[0]} : 'unknown';
    }
}

=item $rv = numeric(scalar);

  Return true if the scalar is a number 
  0,-n,+n
    else
  returns false

=back

=cut

sub numeric {
  return ($_[0] =~ /[^\d\-]/) ? 1:0;
}

%prot = (
#	
#	Assigned Internet Protocol Numbers
#	
#	Decimal    Keyword     Protocol                         References
#	-------    -------     --------                         ----------
	0	=> 'HOPOPT',	# IPv6 Hop-by-Hop Option            [RFC1883]
	1	=> 'ICMP',	# Internet Control Message           [RFC792]
	2	=> 'IGMP',	# Internet Group Management         [RFC1112]
	3	=> 'GGP',	# Gateway-to-Gateway                 [RFC823]
	4	=> 'IP',	# IP in IP (encapsulation)          [RFC2003]
	5	=> 'ST',	# Stream                    [RFC1190,RFC1819]
	6	=> 'TCP',	# Transmission Control               [RFC793]
	7	=> 'CBT',	# CBT                             [Ballardie]
	8	=> 'EGP',	# Exterior Gateway Protocol     [RFC888,DLM1]
#	     9     IGP         any private interior gateway         [IANA]
#	                       (used by Cisco for their IGRP)
	10	=> 'BBN-RCC-MON',	# BBN RCC Monitoring                    [SGC]
	11	=> 'NVP-II',	# Network Voice Protocol         [RFC741,SC3]
	12	=> 'PUP',	# PUP                             [PUP,XEROX]
	13	=> 'ARGUS',	# ARGUS                                [RWS4]
	14	=> 'EMCON',	# EMCON                                 [BN7]
	15	=> 'XNET',	# Cross Net Debugger            [IEN158,JFH2]
	16	=> 'CHAOS',	# Chaos                                 [NC3]
	17	=> 'UDP',	# User Datagram                  [RFC768,JBP]
	18	=> 'MUX',	# Multiplexing                    [IEN90,JBP]
	19	=> 'DCN-MEAS',	# DCN Measurement Subsystems           [DLM1]
	20	=> 'HMP',	# Host Monitoring                [RFC869,RH6]
	21	=> 'PRM',	# Packet Radio Measurement              [ZSU]
	22	=> 'XNS-IDP',	# XEROX NS IDP               [ETHERNET,XEROX]
	23	=> 'TRUNK-1',	# Trunk-1                              [BWB6]
	24	=> 'TRUNK-2',	# Trunk-2                              [BWB6]
	25	=> 'LEAF-1',	# Leaf-1                               [BWB6]
	26	=> 'LEAF-2',	# Leaf-2                               [BWB6]
	27	=> 'RDP',	# Reliable Data Protocol         [RFC908,RH6]
	28	=> 'IRTP',	# Internet Reliable Transaction  [RFC938,TXM]
	29	=> 'ISO-TP4',	# ISO Transport Protocol Class 4 [RFC905,RC77]
	30	=> 'NETBLT',	# Bulk Data Transfer Protocol    [RFC969,DDC1]
	31	=> 'MFE-NSP',	# MFE Network Services Protocol  [MFENET,BCH2]
	32	=> 'MERIT-INP',	# MERIT Internodal Protocol             [HWB]
	33	=> 'SEP',	# Sequential Exchange Protocol        [JC120]
	34	=> '3PC',	# Third Party Connect Protocol         [SAF3]
	35	=> 'IDPR',	# Inter-Domain Policy Routing Protocol [MXS1]
	36	=> 'XTP',	# XTP                                   [GXC]
	37	=> 'DDP',	# Datagram Delivery Protocol            [WXC]
	38	=> 'IDPR-CMTP',	# IDPR Control Message Transport Proto [MXS1]
	39	=> 'TP++',	# TP++ Transport Protocol               [DXF]
	40	=> 'IL',	# IL Transport Protocol            [Presotto]
	41	=> 'IPV6',	# Ipv6                              [Deering]
	42	=> 'SDRP',	# Source Demand Routing Protocol       [DXE1]
	43	=> 'IPV6-ROUTE',	# Routing Header for IPv6           [Deering]
	44	=> 'IPV6-FRAG',	# Fragment Header for IPv6          [Deering]
	45	=> 'IDRP',	# Inter-Domain Routing Protocol   [Sue Hares]
	46	=> 'RSVP',	# Reservation Protocol           [Bob Braden]
	47	=> 'GRE',	# General Routing Encapsulation     [Tony Li]
	48	=> 'MHRP',	# Mobile Host Routing Protocol[David Johnson]
	49	=> 'BNA',	# BNA                          [Gary Salamon]
	50	=> 'ESP',	# Encapsulating Security Payload    [RFC1827]
	51	=> 'AH',	# Authentication Header             [RFC1826]
	52	=> 'I-NLSP',	# Integrated Net Layer Security  TUBA [GLENN]
	53	=> 'SWIPE',	# IP with Encryption                    [JI6]
	54	=> 'NARP',	# NBMA Address Resolution Protocol  [RFC1735]
	55	=> 'MOBILE',	# IP Mobility                       [Perkins]
	56	=> 'TLSP',	# Transport Layer Security Protocol   [Oberg]
#	                       using Kryptonet key management
	57	=> 'SKIP',	# SKIP                              [Markson]
	58	=> 'IPV6-ICMP',	# ICMP for IPv6                     [RFC1883]
	59	=> 'IPV6-NONXT',	# No Next Header for IPv6           [RFC1883]
	60	=> 'IPV6-OPTS',	# Destination Options for IPv6      [RFC1883]
#	    61                 any host internal protocol           [IANA]
	62	=> 'CFTP',	# CFTP                            [CFTP,HCF2]
#	    63                 any local network                    [IANA]
	64	=> 'SAT-EXPAK',	# SATNET and Backroom EXPAK             [SHB]
	65	=> 'KRYPTOLAN',	# Kryptolan                            [PXL1]
	66	=> 'RVD',	# MIT Remote Virtual Disk Protocol      [MBG]
	67	=> 'IPPC',	# Internet Pluribus Packet Core         [SHB]
#	    68                 any distributed file system          [IANA]
	69	=> 'SAT-MON',	# SATNET Monitoring                     [SHB]
	70	=> 'VISA',	# VISA Protocol                        [GXT1]
	71	=> 'IPCV',	# Internet Packet Core Utility          [SHB]
	72	=> 'CPNX',	# Computer Protocol Network Executive  [DXM2]
	73	=> 'CPHB',	# Computer Protocol Heart Beat         [DXM2]
	74	=> 'WSN',	# Wang Span Network                     [VXD]
	75	=> 'PVP',	# Packet Video Protocol                 [SC3]
	76	=> 'BR-SAT-MON',	# Backroom SATNET Monitoring            [SHB]
	77	=> 'SUN-ND',	# SUN ND PROTOCOL-Temporary             [WM3]
	78	=> 'WB-MON',	# WIDEBAND Monitoring                   [SHB]
	79	=> 'WB-EXPAK',	# WIDEBAND EXPAK                        [SHB]
	80	=> 'ISO-IP',	# ISO Internet Protocol                 [MTR]
	81	=> 'VMTP',	# VMTP                                 [DRC3]
	82	=> 'SECURE-VMTP',	# SECURE-VMTP                          [DRC3]
	83	=> 'VINES',	# VINES                                 [BXH]
	84	=> 'TTP',	# TTP                                   [JXS]
	85	=> 'NSFNET-IGP',	# NSFNET-IGP                            [HWB]
	86	=> 'DGP',	# Dissimilar Gateway Protocol     [DGP,ML109]
	87	=> 'TCF',	# TCF                                  [GAL5]
	88	=> 'EIGRP',	# EIGRP                           [CISCO,GXS]
	89	=> 'OSPFIGP',	# OSPFIGP                      [RFC1583,JTM4]
	90	=> 'SPRITE-RPC',	# Sprite RPC Protocol            [SPRITE,BXW]
	91	=> 'LARP',	# Locus Address Resolution Protocol     [BXH]
	92	=> 'MTP',	# Multicast Transport Protocol          [SXA]
	93	=> 'AX.25',	# AX.25 Frames                         [BK29]
	94	=> 'IPIP',	# IP-within-IP Encapsulation Protocol   [JI6]
	95	=> 'MICP',	# Mobile Internetworking Control Pro.   [JI6]
	96	=> 'SCC-SP',	# Semaphore Communications Sec. Pro.    [HXH]
	97	=> 'ETHERIP',	# Ethernet-within-IP Encapsulation     [RDH1]
	98	=> 'ENCAP',	# Encapsulation Header         [RFC1241,RXB3]
#	    99                 any private encryption scheme        [IANA]
	100	=> 'GMTP',	# GMTP                                 [RXB5]
	101	=> 'IFMP',	# Ipsilon Flow Management Protocol   [Hinden]
	102	=> 'PNNI',	# PNNI over IP                       [Callon]
	103	=> 'PIM',	# Protocol Independent Multicast  [Farinacci]
	104	=> 'ARIS',	# ARIS                              [Feldman]
	105	=> 'SCPS',	# SCPS                                [Durst]
	106	=> 'QNX',	# QNX                                [Hunter]
	107	=> 'A/N',	# Active Networks                    [Braden]
	108	=> 'IPCOMP',	# IP Payload Compression Protocol   [RFC2393]
	109	=> 'SNP',	# Sitara Networks Protocol          [Sridhar]
	110	=> 'COMPAQ-PEER',	# Compaq Peer Protocol                [Volpe]
	111	=> 'IPX-IN-IP',	# IPX in IP                             [Lee]
	112	=> 'VRRP',	# Virtual Router Redundancy Protocol [Hinden]
	113	=> 'PGM',	# PGM Reliable Transport Protocol  [Speakman]
#	   114                 any 0-hop protocol                   [IANA]
	115	=> 'L2TP',	# Layer Two Tunneling Protocol        [Aboba]
	116	=> 'DDX',	# D-II Data Exchange (DDX)           [Worley]
	117	=> 'IATP',	# Interactive Agent Transfer Protocol  [Murphy]
	118	=> 'STP',	# Schedule Transfer Protocol            [JMP]
	119	=> 'SRP',	# SpectraLink Radio Protocol       [Hamilton]
	120	=> 'UTI',	# UTI                              [Lothberg]
	121	=> 'SMP',	# Simple Message Protocol            [Ekblad]
	122	=> 'SM',	# SM                             [Crowcroft]
	123	=> 'PTP',	# Performance Transparency Protocol   [Welzl]
	124	=> 'ISIS',	# over IPv4                             [Przygienda]
	125	=> 'FIRE',	# [Partridge]
	126	=> 'CRTP',	# Combat Radio Transport Protocol  [Sautter]
	127	=> 'CRUDP',	# Combat Radio User Datagram       [Sautter]
	128	=> 'SSCOPMCE',	# [Waber]
	129	=> 'IPLT',	# [Hollbach]
	130	=> 'SPS',	# Secure Packet Shield             [McIntosh]
	131	=> 'PIPE',	# Private IP Encapsulation within IP       [Petri]
	132	=> 'SCTP',	# Stream Control Transmission Protocol   [Stewart]
	133	=> 'FC',	# Fibre Channel                        [Rajagopal]
	134	=> 'RSVP-E2E-IGNORE',	# [RFC3175]
#	   135-254             Unassigned                           [IANA]
#	   255                 Reserved                             [IANA]
);
%pnum = reverse %prot;
%icmp = (
#	NAME
#	      LaBrea::Tarpit::Codes
#	
#	SYNOPSIS
#	      use LaBrea::Tarpit::Codes qw (
#	            protocol
#	            icmp
#	            numeric
#	      );
#	
#	      $text   = protocol(number);
#	      $number = protocol(text);
#	      $text   = icmp(number);
#	      $number = icmp(text);
#	      $rv     = numeric(scalar);
#	
#	DESCRIPTION
#	    This module is built by Makefile.PL from the text files in the IANA
#	    subdirectory (copied from the IANA web site).
#	
#	    Do not edit the Codes.pm file, changes will be lost.
#	
#	    $rv = protocol($x);
#	          Returns the upper case text name of a protocol
#	          number or the protocol number of a text name.
#	
#	          i.e.  'TCP' = protocol(6);
#	                  6   = protocol('Tcp');
#	                  (not case sensitive)
#	
#	          return -1 or 'unknown' if lookup value 
#	          is not present in table
#	
#	    $rv = icmp($x);
#	          Returns the upper case text name of an icmp
#	          number or the icmp number of the text name.
#	
#	          i.e.  'ECHO' = icmp(8);
#	                   8   = icmp('EcHo');
#	                   (not case sensitive)
#	
#	          return -1 or 'unknown' if lookup value 
#	          is not present in table
#	
#	    $rv = numeric(scalar);
#	          Return true if the scalar is a number 
#	          0,-n,+n
#	            else
#	          returns false
#	
#	EXPORT
#	      None by default.
#	
#	COPYRIGHT
#	    Copyright 2002, Michael Robinton & BizSystems This program is free
#	    software; you can redistribute it and/or modify it under the terms of
#	    the GNU General Public License as published by the Free Software
#	    Foundation; either version 2 of the License, or (at your option) any
#	    later version.
#	
#	    This program is distributed in the hope that it will be useful, but
#	    WITHOUT ANY WARRANTY; without even the implied warranty of
#	    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#	    Public License for more details.
#	
#	    You should have received a copy of the GNU General Public License along
#	    with this program; if not, write to the Free Software Foundation, Inc.,
#	    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#	
#	AUTHOR
#	    Michael Robinton, michael@bizsystems.com
#	
#	SEE ALSO
#	    perl(1), LaBrea::Tarpit(3), LaBrea::Tarpit::Get(3),
#	    LaBrea::Tarpit::Report(3), LaBrea::Tarpit::Util(3),
#	    LaBrea::Tarpit::DShield(3)
#	
#	    EOF
#	
#	    close C;
#	
);
%inum = reverse %icmp;

1;
__END__

=head1 EXPORT

  None by default.

=head1 COPYRIGHT

Copyright 2002, Michael Robinton & BizSystems
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

=head1 AUTHOR

Michael Robinton, michael@bizsystems.com

=head1 SEE ALSO

perl(1), LaBrea::Tarpit(3), LaBrea::Tarpit::Get(3), LaBrea::Tarpit::Report(3),
LaBrea::Tarpit::Util(3), LaBrea::Tarpit::DShield(3)

