# NOTE: Derived from blib/lib/LaBrea/Tarpit.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package LaBrea::Tarpit;

#line 1084 "blib/lib/LaBrea/Tarpit.pm (autosplit into blib/lib/auto/LaBrea/Tarpit/cull_threads.al)"
# cull old threads
#
# input:	\%tarpit, timeout_seconds, scanners, port_intervals, DShield_file
#			    default 600
# returns:	1 if threads removed, else 0

sub cull_threads {
  my ($tp,$timeout,$scrs,$ph,$ds) = @_;
  my $rv = 0;
  $scrs = ($scrs && $scrs > 0) ? int($scrs) : 0;
  my %scanners;			# trial dead threads
  my $dso;
  local (*LOCK,*DS);
  $timeout = defaults->{cull} unless $timeout;
  my $now = $tp->{now} || time;
  $tp->{tz} = timezone($now);
  my $expired = $now - $timeout;
  my ($src,$sp,$destdp);
  my $act = $tp->{at} || ($tp->{at} = {});	# pointer to active threads
  my @src = keys %{$act};			# active threads
  foreach $src (@src) {
    my @sp = keys %{$act->{$src}};
    foreach $sp ( sort {
	$act->{$src}->{$a}->{lc} <=> $act->{$src}->{$b}->{lc}
	}@sp) {
# process DShield notifications first
      if ( exists $act->{$src}->{$sp}->{DShield} ) {
	if (! $ds) {						# dshield not active
	  delete $act->{$src}->{$sp}->{DShield};		# don't want these around
	}
	elsif ( $dso || ($dso = _ex_append(*LOCK,*DS,$ds)) ) {	# DShield cache open
	  $_ = $tp->{tz};
	  substr($_,-2,0) = ':';				# insert colon in TZ string
	  my ($tza,$tzb) = split(':',$_);			# crude but effective
	  my $dshield = $act->{$src}->{$sp}->{DShield};
	  foreach my $shieldIP (keys %{$dshield}) {		# foreach dest IP
	    foreach my $shieldPort(keys %{$dshield->{$shieldIP}}) {	# and each target port
	      my($sec,$min,$hr,$md,$mon,$yr) = localtime($dshield->{$shieldIP}->{$shieldPort});
	      $_ = sprintf ("%04d-%02d-%02d %02d:%02d:%02d %+03d:%02d\t",$yr+1900,$mon+1,$md,$hr,$min,$sec,$tza,$tzb);
	      print DS $_,'UserID',$tp->{LaBrea},':',$VERSION,"\t1\t$src\t$sp\t$shieldIP\t$shieldPort\tTCP\tSYN\n";
	    }
	  }
	  delete $act->{$src}->{$sp}->{DShield};		# printed, destroy
	}
      }

      if ( $act->{$src}->{$sp}->{lc} < $expired ) {
	@{$scanners{$src}}{'dp','lc','pst'} = @{$act->{$src}->{$sp}}{'dp','lc','pst'};
	delete $act->{$src}->{$sp};			# remove active expired thread
      }
    }
    if (keys %{$act->{$src}}) {				# do threads remain for this IP?
      delete $scanners{$src};			# yes, dispose of parital deaths
    } else {
      delete $act->{$src};			# no, delete active thread
    }
    $rv = 1;
  }
  if ( $dso ) {		# dshield cache open
    close *DS;
    close *LOCK;
  }
  if ($scrs) {		# if scanners are saved
    my $dead = $tp->{dt} || ($tp->{dt} = {});
# add new dead threads
    foreach (keys %scanners) {
      @{$dead->{$_}}{'dp','lc','pst'} = @{$scanners{$_}}{'dp','lc','pst'};
    }
# remove old dead threads over limit
    if ((@_ = keys %{$dead}) > $scrs) {
      my @dead = sort {
	$dead->{$a}->{lc} <=> $dead->{$b}->{lc};
      } @_;
# extract the oldest dead threads
      splice(@dead,@_-$scrs);
      foreach(@dead) {
	delete $dead->{$_};
      }
      $rv = 1;
    }
  }
  if ( $ph ) {		# if port stats are present
    $_ = $tp->{pt} || 86400;
    my $intvls = $ph * $_;
    my $end = $now - ($now % $_) - $intvls + 1;
    foreach(keys %{$tp->{ph}}) {
      if ($_ < $end) {
	delete $tp->{ph}->{$_};		# drop old port stats
	$rv = 1;
      }
    }
  } elsif (exists $tp->{ph}) {
    delete $tp->{ph};				# remove unwanted port stats
    $rv = 1;
  }
  $rv;
}

# end of LaBrea::Tarpit::cull_threads
1;
