# NOTE: Derived from blib/lib/LaBrea/Tarpit.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package LaBrea::Tarpit;

#line 508 "blib/lib/LaBrea/Tarpit.pm (autosplit into blib/lib/auto/LaBrea/Tarpit/daemon.al)"
# make daemon
#
# KILL with signal TERM, -15
# dump cache with SIG_HUP
#
# input:	%hash or \%hash above
#
sub daemon {
  my $pid;
  $_ = ( ref $_[0] ) ? $_[0] : {@_};
  my ($LaBrea,$config,$pid_file,$max_kids,$d_port,$d_host,$allowed,$cache_file,$umask,$cull,$scrs,   $ph,        $pt,       $ds,   $DEBUG) = @{$_}{
    qw(LaBrea  config  pid           kids  d_port  d_host  allowed  cache       umask  cull scanners port_intvls port_timer DShield DEBUG)};

# fork and test
  unless ( $pid = fork ) {
# clean up for proper daemon operation
    chdir '/';			# allow root dismount
    open STDIN, '/dev/null'	or die "Can't read /dev/null: $!";
    open STDOUT, '>/dev/null'	or die "Can't write to /dev/null: $!";
    unless ( $pid = fork ) {
      local(*SERVER,*CLIENT);

      require LaBrea::NetIO;
      import LaBrea::NetIO qw(
	open_listen_sock
	reap_kids
	set_so_linger
	sockaddr_in
	inet_ntoa
      );

# open server port

      die $_ if ($_ = open_listen_sock(*SERVER,$d_host,$d_port));
      my $flags = fcntl(SERVER,F_GETFL,0)	|| die "can't get socket flags";
      fcntl(SERVER,F_SETFL,$flags | O_NONBLOCK)	|| die "can't set socket non-blocking";

      require POSIX;
      my $tarpit = {};
      &POSIX::setsid()	or die "Can't start new session: $!";
      my($LBfh,$version,$kid) = lbd_open($LaBrea,$DEBUG);
      $umask = 033 unless $umask;
      $cull = defaults->{cull} unless $cull;
      $ph = 0 unless $ph;
      my $time2cull = time + $cull;	# first cull must wait

##### define signal services within this scope

      my $run = 1;
      my $hup = 0;

$__PACKAGE__::DOWARN = 0;		# quite warnings about 
      my $quit = sub {			# portability of $run, $hup
	$run = 0;
      };
      my $dohup = sub {
	$hup = 1;
      };
$__PACKAGE__::DOWARN = 1;

#      local $SIG{HUP} = $dohup;
#      local $SIG{INT} = $dohup;
#      local $SIG{TERM} = $quit;

      local $SIG{HUP} = sub { $hup = 1; };
      local $SIG{INT} = sub { $hup = 1; };
      local $SIG{TERM} = sub { $run = 0; };
      local $SIG{PIPE} = 'IGNORE';

      &restore_tarpit($tarpit,$cache_file) if -e $cache_file;
      $tarpit->{LaBrea} = $version;	# set version number
      $tarpit->{pt} = $pt || 86400;	# default data collection is one day

# prepare daemon loop
      my $WNOHANG = &POSIX::WNOHANG; 
      my $rin = '';
      vec($rin,fileno($LBfh),1) = 1;
      my $timeout = defaults->{s_timeout};
      my ($rout,$paddr,%kids);

      my @valid_clients;
      foreach(split(',', $allowed)) {
	(undef,undef,undef,undef,@_) = gethostbyname($_);
	push @valid_clients,@_;
      }

      $max_kids = 5 unless $max_kids;
      my $kids = 0;		# number of kids alive
      while($run) {
# accept for SERVER is not set for 'select', find it with the POLL
	my $ready = select($rout=$rin,undef,undef,$timeout);
	if ( $ready > 0 ) {
	  $_ = <$LBfh>;	# blocks, but doesn't matter here
	  last unless $_;	# Oops, LaBrea must have died, EXIT
	  &log2_mem($tarpit,$_,1,$ph,$ds);
#	  &_cullnsquish($tarpit,\$time2cull,defaults->{auto_cull},$cull,$scrs,$ph,$ds,$pt,$cache_file,$umask,$version);
	  if (&_check4cull($tarpit,\$time2cull,defaults->{auto_cull},$cull,$scrs,$ph,$ds)) {	# cull every few minutes
		;
# revert cull operation to previous behavior
# the code below does not seem to improve memory usage
#	    my $cache_txt = &write_cache_file($tarpit,$cache_file,$umask,1);	# write cache file and return cache text
#	    $tarpit = {};							# collapse tarpit hash;
#	    my @lines = split("\n",$cache_txt);
#	    &array2_tarpit($tarpit,\@lines);					# returns true
#	    $tarpit->{LaBrea} = $version;					# set version number
#	    $tarpit->{pt} = $pt || 86400;					# default data collection is one day
	  }
	} 
	elsif ( $hup ) {
#	  &write_cache_file($tarpit,$cache_file,$umask,1) unless
#	    &_cullnsquish($tarpit,\$time2cull,defaults->{min_age},$cull,$scrs,$ph,$ds,$pt,$cache_file,$umask,$version);	# cull immediate
	  &_check4cull($tarpit,\$time2cull,defaults->{auto_cull},$cull,$scrs,$ph,$ds);	# cull immediate
	  &write_cache_file($tarpit,$cache_file,$umask,1);				# and write cache file
	  $hup = 0;
	}
	elsif ( $kids < $max_kids && ($paddr = accept(CLIENT,SERVER)) ) {	# client has connected
	  if ($pid = fork) {
	    close CLIENT; 			# close if parent
	    $kids{$pid} = ++$kids if $pid;	# bump kid count, val is not used
	  } else {				# CHILD, service request
	    close SERVER;

########### CHILD PROCESS #################

	    local $SIG{ALRM} = sub { die "child connect timeout" };

	    my $iaddr = (sockaddr_in($paddr))[1];
	    unless ( ( ! @valid_clients || 			# allow all
			 grep($_ == $iaddr,@valid_clients)) && 	# or small number
			set_so_linger(*CLIENT,30)) {		# linger 30 seconds to deliver stuff
	      close CLIENT;
	      exit 0;			# exit silently if not allowed or can't set linger
	    }
	    
	    &_check4cull($tarpit,\$time2cull,defaults->{min_age},$cull,$scrs,$ph,$ds);	# cull immediate

	    eval {
	      my $cache_txt = '';
	      alarm defaults->{sock_timeout};
	      my $request = readline *CLIENT;
	      if ( $request =~ /^standard/ ) {			# full tarpit contents
		$request = $tarpit;
	      }
	      elsif ( $request =~ /^short/ ) {			# short totals only
		$request = { 'Tarpit'	=> $VERSION };		# version in format for other end
		prep_report($tarpit,$request);
	      }
	      elsif ( $request =~ /^active/ ) {		# only active threads
		$request = { 'at' => $tarpit->{at} };
	      }
	      elsif ( $request =~ /^config/ ) {		# return config info
		if ( $config ) {
		  if (ref $config) {	# if it is array format
		    @_ = @{$config};
		  } else {
		    @_ = ($config);
		  }
		  my ($hard_ex,$exclude,$new_config);
		  if ( $_[0] =~ /Exclude/ ) {		# old style
		    if ( $_[0] =~ /Hard/ ) {
		      $cache_txt .= &_get_config($_[0],'hardexclude');
		    } else {
		      $cache_txt .= &_get_config($_[0],'exclude');
		    }
		    if ( @_ > 1 ) {			# if second argument
		      if ( $_[1] =~ /Hard/ ) {
			$cache_txt .= &_get_config($_[1],'hardexclude');
		      } elsif ( $_[1] =~ /Exclude/ ) {
			$cache_txt .= &_get_config($_[1],'exclude');
		      }
		    }
		  } elsif ( $_[0] =~  /Config/ ||
				      /LaBrea\.cfg/ ) {	# new style, config true
		    
		    $cache_txt .= &_get_config($_[0],'');
		  }
		} # end config file info
		$cache_txt = "none\n" unless $cache_txt;

	      } else {		# unknown

		alarm 0;
		close CLIENT;
		exit 0;
	      }

	      &_cache2txt(\$cache_txt,$request,'daemon') unless $cache_txt;
	      my $len = length($cache_txt);
	      my $off = 0;
	      my $win = '';
	      my ($wout,$eout);
	      vec($win,fileno(CLIENT),1) = 1;
	      my $ein = $win;
	      while ($len) {
		$ready = select(undef,$wout=$win,undef,defaults->{pipe_timeout});	# block until write or error
		last unless $ready;		# punt if timeout
		my $wrote = syswrite(CLIENT,$cache_txt,$len,$off);
		last unless defined $wrote;	# only errors
#	      if ( ! defined $wrote ) {
#		next if $! == EAGAIN;		# would block
#	      }
		$off += $wrote;
		$len -= $wrote;
	      }
	    };	
	    alarm 0;
	    close CLIENT;
	    exit 0;				# child dies
	  }
########### END CHILD #################
	}
	else {
	  $kids = reap_kids(\%kids);		# dispose of dead kids, return remaining number
	}
      }
      lbd_close($LBfh,$kid);
      &_check4cull($tarpit,\$time2cull,defaults->{min_age},$cull,$scrs,$ph,$ds);	# cull threads
      &write_cache_file($tarpit,$cache_file,$umask,1);
      foreach $kid ( keys %kids ) {
	kill 15, $kid;				# kill remaining children
      }
      unlink $pid_file;
      exit 0;
    }
    exit 1 unless open(PID,'>'.$pid_file);
    print PID $pid, "\n";
    close PID;
    exit 0;
  }
  waitpid($pid,0);
}

# end of LaBrea::Tarpit::daemon
1;
