# NOTE: Derived from blib/lib/LaBrea/Tarpit.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package LaBrea::Tarpit;

#line 950 "blib/lib/LaBrea/Tarpit.pm (autosplit into blib/lib/auto/LaBrea/Tarpit/log2_mem.al)"
# update the tarpit cache from log line, see comments below for format
#
# input:	\%tarpit, log_line, is_daemon, port_intvls, DShield_flag
#
#
sub log2_mem {
  my ($tp,$line,$id,$ph,$ds) = @_;
  return undef if (!$id && $line !~ /LaBrea:/);
# valid Labrea log line to parse
  if ( $line =~ /.+bw:\s+(\d+)\s+/ ) {	# if bandwidth line
    $tp->{bw} = $1 || 0;
    return 1;
  }
  # extract time / date
  my $time;
  if ( $line =~ /^(\d+)\s+/ ) {
    $time = $1;
  } else {		# complex form
    require Time::Local;
    return undef unless $line =~ /(.+)\s+(\d+):(\d+):(\d+)\s+(\w+)\s+/;
    @_ = split(/\s+/,$1);
    my $day = pop @_;
    my $mon = pop @_;
    $mon = mon->{"\L$mon"};
    my ($hr,$min,$sec,$yr) = ($2,$3,$4,$5);
    if ($yr =~ /[^\d]/) {
      my ($nowmo,$nowyr) = (localtime(time))[4,5];
      $yr = ($mon > $nowmo)		# roll over to new year??
	? $nowyr -1
	: $nowyr;
    } elsif ( $yr > 1900 ) {	# most likely
      $yr -= 1900;
    } elsif ( $yr < 70 ) {	# yr 2000 or more
      $yr += 100;
    }				# else leave as-is, 70 - 99
    $time = &Time::Local::timelocal($sec,$min,$hr,$day,$mon,$yr);
  }
# extract ip's and ports                     src              sp                 dest               dp
  return undef unless $line =~ /:\s+(\d+\.\d+\.\d+\.\d+)\s+([na\d]+)[^\d]+(\d+\.\d+\.\d+\.\d+)\s+([na\d]+)/;
  $tp->{now} = $time if (! $tp->{now}) || $tp->{now} < $time;
  my ($src,$sp,$dest,$dp) = ($1,$2,$3,$4);
  delete $tp->{dt}->{$src} if $tp->{dt}->{$src};	# remove dead soldiers
  $_ = $tp->{at}->{$src}->{$sp} || ($tp->{at}->{$src}->{$sp} = {});
  $_->{dip}	= $dest;
  $_->{dp}	= $dp;
  $_->{pst}	= ($line =~ /Persist/i) ? 6 : 0;
  $_->{ct}	= $time unless exists $_->{ct};
  $_->{lc}	= $time;
  if ( $ds && $line =~ /Initial/i ) {			# mark for DShield
    $_->{DShield} = {} unless $_->{DShield};
    $_->{DShield}->{$dest} = {} unless $_->{DShield}->{$dest};
    $_->{DShield}->{$dest}->{$dp} = $time;
  }

  if ( $ph ) {			# if port statistics are collected
    $_ = $tp->{pt} || 86400;
    $time -= ($time % $_);
    if (exists $tp->{ph}->{$time}->{$dp}) {
      $tp->{ph}->{$time}->{$dp} += 1;
    } else {
      $tp->{ph}->{$time}->{$dp} = 1;
    }
  }
  return 1;
}

# end of LaBrea::Tarpit::log2_mem
1;
