# NOTE: Derived from blib/lib/LaBrea/Tarpit.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package LaBrea::Tarpit;

#line 1328 "blib/lib/LaBrea/Tarpit.pm (autosplit into blib/lib/auto/LaBrea/Tarpit/prep_report.al)"
sub prep_report {
  my ($tp,$p) = @_;
# establish array pointers / flags
  my ($tgsip,$tgsp,$tgdip,$tgdp,$tgcap,$tglst,$tgpst);
  my ($thsip,$thnum);
  my ($csdays,$csdate,$csctd);
  my ($phdip,$phpst);
  my ($scsip,$scdp,$scpst,$sclst);
  my ($pintvls,$ports,$pstats);

  my $TCP = 6;		# persistent protcol

  $p->{LaBrea} = $tp->{LaBrea} || 'unknown';
  my (@now,%phantoms,%threadays);
  $now[0] = $p->{now} = $tp->{now} || time;
  $tp->{tz} = &timezone($now[0]) unless $tp->{tz};
  my $tz = $tp->{tz};

  if (exists $p->{tg_srcIP} && exists $p->{tg_sPORT}) {
    $tgsip	= $p->{tg_srcIP};
    $tgsp	= $p->{tg_sPORT};
    $tgdip	= &_init_pt($p,'tg_dstIP');
    $tgdp	= &_init_pt($p,'tg_dPORT');
    $tgcap	= &_init_pt($p,'tg_captr');
    $tglst	= &_init_pt($p,'tg_last');
    $tgpst	= &_init_pt($p,'tg_prst');

  }
  if ($thsip = &_init_pt($p,'th_srcIP')) {
    $thnum	= &_init_pt($p,'th_numTH');
  }
  if ($p->{cs_days} && exists $p->{cs_date} && exists $p->{cs_ctd}) {
    $csdays	= $p->{cs_days};
    $csdays	= ($p->{cs_days} && $p->{cs_days} > 1)
	? $p->{cs_days}
	: 2;
    $csdate	= &_init_pt($p,'cs_date');
# default 'capture this date'
    $csctd	= &_init_pt($p,'cs_ctd');
    $now[0] = $p->{now};
    foreach(1..$csdays-1) {
      $now[$_] = $now[$_-1] - 86400;	# previous days
    }
    foreach(0..$#now) {
      $now[$_] = midnight($now[$_],$tz);
    }
  }
  if (&_init_pt($p,'ph_dstIP')) {
    $phdip	= $p->{ph_dstIP};
    $phpst	= &_init_pt($p,'ph_prst');
  }
  if (&_init_pt($p,'sc_srcIP')) {
    $scsip	= $p->{sc_srcIP};
    $scdp	= &_init_pt($p,'sc_dPORT');
    $scpst	= &_init_pt($p,'sc_prst');
    $sclst	= &_init_pt($p,'sc_last');
  }

  my ($tot,$tg,$th,$cs) = (0,0,0,0);	# event counters

  my $act = $tp->{at} || ($tp->{at} = {});

  my @src = sort keys %$act;
  $p->{total_IPs} = @src;		# total hosts teergrubed

  foreach my $src (@src) {		# each black host
    my @sp = sort keys %{$act->{$src}};
    $tot += @sp;
    if ($thsip) {
      $thnum->[$th] = @sp if $thnum;
      $thsip->[$th++] = $src;		# threads per IP report
    }
    foreach my $sp (@sp) {
      $phantoms{$act->{$src}->{$sp}->{dip}}	# prep phantoms report
	= $act->{$src}->{$sp}->{pst} if $phdip;
      if ($csdate) {			# capture report
	my $capt = &midnight($act->{$src}->{$sp}->{ct},$tz);
	$threadays{$capt} = (exists $threadays{$capt}) 
		? $threadays{$capt} + 1
		: 1;
	$cs++;
      }
      if ($tgsip) {			# teergrube report
	$tgdip->[$tg]	= $act->{$src}->{$sp}->{dip} if $tgdip;
	$tgdp->[$tg]	= $act->{$src}->{$sp}->{dp}  if $tgdp;
	$tgcap->[$tg]	= $act->{$src}->{$sp}->{ct}  if $tgcap;
	$tglst->[$tg]	= $act->{$src}->{$sp}->{lc}  if $tglst;
	$tgpst->[$tg]	= $act->{$src}->{$sp}->{pst} if $tgpst;
	$tgsip->[$tg]	= $src;
	$tgsp->[$tg++]	= $sp;
      }
    }
  }
  if ($phdip) {				# complete phantoms report
    $p->{phantoms} = @_ = sort keys %phantoms;
    @{$phdip}	= @_;
    if ($phpst) {
      @{$phpst} = @phantoms{@_};
      $p->{ph_capt} = &_add_array($phpst,$TCP);
    }
  }
  if ($csdate) {			# finish capture report
    my $k = 0;
    foreach(0..$#now-1) {  
      $csdate->[$_]	= $now[$_];
      $csctd->[$_]	= $threadays{$now[$_]} || 0;
      $k 	       += $csctd->[$_];
    }
    $csdate->[$#now]	= $now[$#now];
    $csctd->[$#now]	= $cs - $k;
  }

# build report elements
  $p->{tz} = $tz;
  $p->{bw} = &bandwidth($tp);
  $p->{threads} = $tot;

# fill remaining conditional
  $p->{tg_capt} = &_add_array($tgpst,$TCP) 
	if $tgsip && $tgpst;

# this one is really totally independent
  if ($scsip) {				# dropped scanner report
    my $dead = $tp->{dt} || ($tp->{dt} = {});
    $p->{sc_total} = @{$scsip} = @_= sort keys %$dead;
    foreach(0..$#_) {
      $scdp->[$_]	= $dead->{$_[$_]}->{dp}	 if $scdp;
      $sclst->[$_]	= $dead->{$_[$_]}->{lc}	 if $sclst;
      $scpst->[$_]	= $dead->{$_[$_]}->{pst} if $scpst;
    }
    $p->{sc_capt} = &_add_array($scpst,$TCP) if $scpst;
  }

# ports also totally independent
  if (exists $p->{port_intvls} &&
	$p->{port_intvls} &&
	exists $p->{ports} &&
	exists $p->{portstats}) {	# port statistics report

    $pintvls = $p->{port_intvls};
    $p->{pt} = $tp->{pt} || 86400;
    $ports = $p->{ports};
    $pstats = $p->{portstats};
    @now = $p->{now};
    $now[0] -= ($now[0] % $p->{pt});
    foreach(1..$pintvls-1) {
      $now[$_] = $now[$_ -1] - $p->{pt};	# fill now with intvls of interest
    }
  # get port numbers so we have them all
    my @pnums;
    foreach (@now) {
      push @pnums, (keys %{$tp->{ph}->{$_}})
	if exists$tp->{ph}->{$_};
    }
    @_ = sort { $a <=> $b } @pnums;
    @pnums = ();
    my $lastp = 0;			# no port zero
    foreach (@_) {			# remove duplicates
      next if $_ == $lastp;
      $lastp = $_;
      push @pnums, $lastp;
    }
    @$ports = @pnums;			# export ports
    @$pstats = ();			# clear stats
    foreach(0..$#pnums) {		# fill stats array
      my $i = $pintvls * $_;		# index into array for port
      foreach my $d (0..$#now) {	# get data for each time slice
        ${$pstats}[$i+$d] = $tp->{ph}->{$now[$d]}->{$pnums[$_]} || 0;
      }
    }
  }
}

# end of LaBrea::Tarpit::prep_report
1;
